//================================================================================================
//                                  cIotModuleOth header
//================================================================================================

class cIotModuleOth
{
  public:

    static const uint8_t MAX_SWQENCODER_CHANNELS = 8;
    static const uint8_t MAX_PERIOD_CHANNELS = 8;

  private:

    const int8_t QuadratureTable[16] = {0, -1, 1, 0, 1, 0, 0, -1, -1, 0, 0, 1, 0, 1, -1, 0};

    struct sSingleSWQEncoderParams
    {
      uint8_t PinA_Name;
      uint8_t PinB_Name;
      uint8_t PinAB_Status;
      uint8_t PinAB_StatusOld;
      uint16_t QuadratureCount;
      bool Attached;
    };

    struct sAllSWQEncodersData
    {
      struct sSingleSWQEncoderParams Params[MAX_SWQENCODER_CHANNELS];
    };

    struct sAllSWQEncodersData SWQEncodersData;

    struct sSinglePeriodParams
    {
      uint8_t PinName;
      uint32_t Count;
      uint32_t TimeCounterOld;
      bool Attached;
    };

    struct sAllPeriodsData
    {
      struct sSinglePeriodParams Params[MAX_PERIOD_CHANNELS];
    };

    struct sAllPeriodsData PeriodsData;

    static void SWQEncoderOnChangeCommon(void *arg, const uint8_t Channel);
    static void ISR_SWQEncoderOnChange_0(void *arg);
    static void ISR_SWQEncoderOnChange_1(void *arg);
    static void ISR_SWQEncoderOnChange_2(void *arg);
    static void ISR_SWQEncoderOnChange_3(void *arg);
    static void ISR_SWQEncoderOnChange_4(void *arg);
    static void ISR_SWQEncoderOnChange_5(void *arg);
    static void ISR_SWQEncoderOnChange_6(void *arg);
    static void ISR_SWQEncoderOnChange_7(void *arg);
    static void PeriodOnRiseCommon(void *arg, const uint8_t Channel);
    static void ISR_PeriodOnRise_0(void *arg);
    static void ISR_PeriodOnRise_1(void *arg);
    static void ISR_PeriodOnRise_2(void *arg);
    static void ISR_PeriodOnRise_3(void *arg);
    static void ISR_PeriodOnRise_4(void *arg);
    static void ISR_PeriodOnRise_5(void *arg);
    static void ISR_PeriodOnRise_6(void *arg);
    static void ISR_PeriodOnRise_7(void *arg);

  public:

    cIotModuleOth();
    void Initialize(void);
    void PreFuota(void);
    bool SWQEncoderAttach(const uint8_t Channel, const uint8_t PinA_Name, const uint8_t PinB_Name);
    bool SWQEncoderDetach(const uint8_t Channel);
    bool SWQEncoderGetQuadratureCount(const uint8_t Channel, int16_t *QuadratureCount);
    bool PeriodAttach(const uint8_t Channel, const uint8_t PinName);
    bool PeriodDetach(const uint8_t Channel);
    bool PeriodGetCount(const uint8_t Channel, uint32_t *Count);
};

