#ifndef IotModuleSetup_h
#define IotModuleSetup_h
//====================================================================================================

#define IOTMODULE_LOG_LEVEL ESP_LOG_NONE  // ESP_LOG_NONE or ESP_LOG_VERBOSE to test with the serial

//====================================================================================================

#define IOTMODULE_PINOUT_TYPE 1   //  1 = ESP32-PICO-KIT V4  /  0 = ESP32-WROOM-32 
#define IOTMODULE_INOUT_PINS 99   //  0 to 99  (99 = all pins) (Wroom 26 pins / PICO 28 pins)
#define IOTMODULE_ADC24_PINS 0    //  0 to 16  (1 to 16 to enable the Adc24 module)
#define IOTMODULE_GENERIC_PINS 0  //  0 to 20  (0 normally)

//====================================================================================================

#define IOTMODULE_WIFI_SSID "Name"          //  SSID name
#define IOTMODULE_WIFI_PASSWORD "Password"  //  SSID password

//====================================================================================================

#define IOTMODULE_WIFI_MODE 0     //  0 = Station mode  /  1 = SoftAP mode
#define IOTMODULE_WIFI_CHANNEL 1  //  WiFi channel 1 to 13 (only relevant in SoftAP mode)

// IF IOTMODULE_WIFI_MODE = 1 (SoftAP) and IOTMODULE_STATIC_IP is not defined (DHCP mode)
//   THEN the default ESP32 network is "192.168.4.1 192.168.4.1 255.255.255.0 0.0.0.0"

// IF IOTMODULE_WIFI_MODE = 1 (SoftAP mode) or IOTMODULE_WIFI_MODE = 0 (Station mode)
//   AND ALSO IOTMODULE_STATIC_IP is defined (Static IP mode) 
//   THEN the network is configured as per IOTMODULE_STATIC_IP

// Uncomment and adapt this line to use the Static IP mode                               
// #define IOTMODULE_STATIC_IP "192.168.11.1 192.168.11.254 255.255.255.0 8.8.8.8"
//                              (module IP)  (gateway IP)   (net mask)    (DNS IP)

// Uncomment and adapt this line to use a different port number (default is 49153)
// #define IOTMODULE_UDP_PORT_NUMBER 49153  //  UDP port number for IotHAL communication

//====================================================================================================

#define IOTMODULE_ENCODERS_TYPE 1               // 1 = Software encoders (x4) / 0 = Hard. encoders (x2)
#define IOTMODULE_FUOTA_ENABLE 1                // 1 = FUOTA enabled / 0 = FUOTA disabled 
#define IOTMODULE_ADC24_COMMUNICATION_SPEED 16  // 1 to 16 MHz (only relevant for the ADC24 board)
#define IOTMODULE_OUTPUT_WATCHDOG_ENABLE 1      // 1 = set all OUT to zero if communication is lost

//====================================================================================================
#endif
